(function ($) {
	$(function(){
		MultisiteMigrationCoreJSObject.init();	
    });
    window.MultisiteMigrationCoreJSObject = {
    	/**
    	 * Initialize
    	 */
    	init: function() {
    		this.handleSingleSiteExport();
    		this.doExport();	
    		this.doImport();   		
    	},
    	/**
    	 * Handle single site export target ID
    	 */
    	handleSingleSiteExport: function() {
    		var multisite_export_checkbox = '#js-multisite-migration-export-as-multisite-1';
    	        $(multisite_export_checkbox).change(function() {
    	    	    $("#js-prime-mover-export-to-multisite-div-1").slideToggle(); 
    	    	    $('.js-multisite-migration-export-now-button').prop('disabled', false);
    	    	    $("#js-multisite-migration-export-targetid").val('');
    	    	    if ($(this).is(':checked')) {    	    	    	
    	    	    	$('.js-multisite-migration-export-now-button').prop('disabled', true);
    	        		$("#js-multisite-migration-export-targetid").on('keyup', function () {
    	        			var value = $(this).val();
    	        			value = value.trim();    		
    	        			$('.js-multisite-migration-export-now-button').prop('disabled', true);
    	        			if (value && MultisiteMigrationCoreJSObject.isValidBlogId(value)) {
    	        			    $('.js-multisite-migration-export-now-button').prop('disabled', false);
    	        			}
    	        		});   	    	    	
    	    	    }
    	        });
    	},
    	/**
    	 * Checks if valid ID is passed
    	 */
    	isValidBlogId: function(str) {    		
    		    var n = Math.floor(Number(str));
    		    return n !== Infinity && String(n) === str && n > 1;    		   		
    	},
        /**
         * Search something in JavaScript object
         */
    	searchInObject: function(nameKey, myArray, ret_type){
            if (typeof(ret_type) === 'undefined') {
            	var ret_type = 'bool';
            }            
    	    for (var i=0; i < myArray.length; i++) {
    	        if (myArray[i].filename === nameKey) {
    	        	if ('bool' === ret_type) {
    	        		return true;        		
    	        	} 
    	        	if ('key' === ret_type) {
    	        		return i;
    	        	}    	            
    	        }
    	    }
    	    return false;
    	},
    	/**
    	 * Request import
    	 */
    	doImport: function() {
    		var import_column = 'body';
    		$(import_column).on('click','input.js-multisite_migration_importbrowsefile' , function(){ 
    			$(this).val( null );	
    			var multisiteblog_id = $(this).attr("data-multisiteblogid");
    			if (multisiteblog_id) {
    				MultisiteMigrationCoreJSObject.cleanProgressSpans(multisiteblog_id, 'import');   				
    			}    			
    		});	
    		$(import_column).on('change','input.js-multisite_migration_importbrowsefile' , function(){     			
    			var multisiteblog_id = $(this).attr("data-multisiteblogid");	
    			if ( ( parseInt( multisiteblog_id ) > 0 ) && ( parseInt( $(this)[0].files[0].size ) > 0 ) ) {
    				var uploaderror_selector = MultisiteMigrationCoreJSObject.getGenericFailSelector(multisiteblog_id);
    				MultisiteMigrationCoreJSObject.initializeDialogMonitor(uploaderror_selector, true);
    				var ext = $(this).val().split('.').pop().toLowerCase();
    				console.log(multisite_migration_js_ajax_renderer.prime_mover_phpuploads_misconfigured);
    				if($.inArray(ext, ['zip']) == -1) {
    					MultisiteMigrationCoreJSObject.user_notices( "#js-multisite-migration-wrong-filetype-" + multisiteblog_id, 0, '', false, multisite_migration_js_ajax_renderer.prime_mover_invalid_package); 
    				} else if (multisite_migration_js_ajax_renderer.prime_mover_phpuploads_misconfigured) {
    					MultisiteMigrationCoreJSObject.user_notices( "#js-multisite-migration-wrong-filetype-" + multisiteblog_id, multisiteblog_id, 'import', true, multisite_migration_js_ajax_renderer.prime_mover_upload_misconfiguration_error);   				    	
    				} else {    				
    					MultisiteMigrationCoreJSObject.initiateSpinner(multisiteblog_id, 'zip_analysis');
    					var the_import_package = $(this)[0].files[0];    					
    					MultisiteMigrationCoreJSObject.processZipJs(the_import_package, multisiteblog_id);                        
    				}			
    			}		
    		});    		
    	},
    	/**
    	 * Process zip
    	 */
    	processZipJs: function(the_import_package, multisiteblog_id) {
			zip.workerScriptsPath = multisite_migration_js_ajax_renderer.prime_mover_zipjs_workers;    					
			zip.createReader(new zip.BlobReader(the_import_package), function(reader) {
			    reader.getEntries(function(entries) {
			    if (entries.length) {
			        var zipfoldername = entries[0].filename;
			        var signaturefile = zipfoldername + 'signature.enc';
			        var mediasignaturefile = zipfoldername + 'media.enc';
			        
					var encrypted = false; 
					var encrypted_media = false;					
					var signature_key = MultisiteMigrationCoreJSObject.searchInObject(signaturefile, entries, 'key');
					if (false !== signature_key) {
						encrypted = true;
					}				
					
					var media_signature_key = MultisiteMigrationCoreJSObject.searchInObject(mediasignaturefile, entries, 'key');
					if (false !== media_signature_key) {
						encrypted_media = true;
					}	
					
				    MultisiteMigrationCoreJSObject.handleEncryptedPackageCheck(encrypted, signaturefile, entries, signature_key, reader, the_import_package, zipfoldername, multisiteblog_id, encrypted_media);				    
			    } else {
			    	MultisiteMigrationCoreJSObject.user_notices( "#js-multisite-migration-wrong-filetype-" + multisiteblog_id, multisiteblog_id, 'import', true, multisite_migration_js_ajax_renderer.prime_mover_invalid_package); 
			    }
				  });
				}, function(error) {			
					var package_size = the_import_package.size;
					if (package_size > 4294967296) {
						error = multisite_migration_js_ajax_renderer.prime_mover_exceeded_browser_limit;
					}
					MultisiteMigrationCoreJSObject.user_notices( "#js-multisite-migration-wrong-filetype-" + multisiteblog_id, multisiteblog_id, 'import', true, error); 
				});    		
    	},
    	/**
    	 * Do after client package validation
    	 */
    	doAfterPackageClientValidation: function(the_import_package, entries, reader, zipfoldername, multisiteblog_id, encrypted, encrypted_media) {    		
		    var exported_mode_texts = MultisiteMigrationCoreJSObject.analyzeRestoreMode(entries, zipfoldername, multisiteblog_id);							  
		    var footprint_path = zipfoldername + 'footprint.json';		    
		    var footprint_key = MultisiteMigrationCoreJSObject.searchInObject(footprint_path, entries, 'key');	 
		    if (footprint_key) {
	            entries[footprint_key].getData(new zip.TextWriter(), function(text) { 
	            var footprint_var = JSON.parse(text);
				var site_title = footprint_var['site_title'];            							
				
				var correctBlogID = Number(multisiteblog_id);
				var wrongselector = '#js-multisite-migration-wrong-importedsite-' + multisiteblog_id;
				zipfoldername.replace(/\s+/g, '');				

				var blogidimported = MultisiteMigrationCoreJSObject.getBlogIDfromFolderName(zipfoldername);
				if ( ! blogidimported || ! correctBlogID ) {
					MultisiteMigrationCoreJSObject.user_notices(wrongselector, multisiteblog_id, 'import', true);	
				}					
				if (blogidimported !== correctBlogID) {					
					MultisiteMigrationCoreJSObject.user_notices(wrongselector, multisiteblog_id, 'import', true);						
				} else {					
					MultisiteMigrationCoreJSObject.cleanProgressSpans(multisiteblog_id, 'import'); 
					/** exported_mode_texts is an array */
					MultisiteMigrationCoreJSObject.generalImportWarningDialog(multisiteblog_id, the_import_package, '', '', '', encrypted, 
							exported_mode_texts, site_title, the_import_package.name, '', encrypted_media);    								
				}				
		        reader.close(function() {});	
		        
	            }, function(current, total) {});             
		    } else {
		    	MultisiteMigrationCoreJSObject.user_notices( "#js-multisite-migration-wrong-filetype-" + multisiteblog_id, multisiteblog_id, 'import', true, multisite_migration_js_ajax_renderer.prime_mover_invalid_package); 
		    }   		
    	},
    	/**
    	 * Handle encrypted package check
    	 */
    	handleEncryptedPackageCheck: function(encrypted, signaturefile, entries, signature_key, reader, the_import_package, zipfoldername, multisiteblog_id, encrypted_media) {
		    if (encrypted) {
	            entries[signature_key].getData(new zip.TextWriter(), function(text) {		        	
		  		    var data = {
		  			    action: 'prime_mover_verify_encrypted_package',
		  			   	dataType: 'json',	 
		  			   	stringtocheck: text,
		  			   	encrypted_media: encrypted_media,
		  			    prime_mover_decryption_check_nonce: multisite_migration_js_ajax_renderer.prime_mover_decryption_check_nonce,
		  			    multisiteblog_id: multisiteblog_id
		  			};
		        	
			 	     $.post( multisite_migration_js_ajax_renderer.ajaxurl, data, function(response) {
			 	    	    if (response.result) {
			 	    	    	MultisiteMigrationCoreJSObject.doAfterPackageClientValidation(the_import_package, entries, reader, zipfoldername, multisiteblog_id, encrypted, encrypted_media); 			 	    	    	
			 	    	    } else {
			 	    	    	var error_message = response.error;
			                	MultisiteMigrationCoreJSObject.user_notices( "#js-multisite-migration-wrong-filetype-" + multisiteblog_id, multisiteblog_id, 'import', true, error_message);   
			    		        reader.close(function() {});			 	    	    	
			 	    	    }			 	    	 
			 	     }).fail(function(xhr, status, error) {
			 	    	var ajax_handler_object = this;	 	    	
			   	 	    MultisiteMigrationCoreJSObject.doErrorHandling( multisiteblog_id, 'import', ajax_handler_object, null, true, 'handleEncryptedPackageCheck' );		   	 	    
			 	     }); 		        	
		        }, function(current, total) {}); 			    				    	   							    	
		    } else {
		    	MultisiteMigrationCoreJSObject.doAfterPackageClientValidation(the_import_package, entries, reader, zipfoldername, multisiteblog_id, encrypted, encrypted_media);	    	
		    }		    
    	},
    	/**
    	 * Analyze restore mode
    	 */
    	analyzeRestoreMode: function(zipfiles, zipfoldername, multisiteblog_id) {     		
    		var restore_mode = [];
    		var plugins = zipfoldername + 'plugins' + '/';
			var media = zipfoldername + 'media.zip';			

			if (MultisiteMigrationCoreJSObject.searchInObject(plugins, zipfiles)) {
				if (MultisiteMigrationCoreJSObject.searchInObject(media, zipfiles)) {
					restore_mode['complete_export_mode'] = multisite_migration_js_ajax_renderer.multisite_migration_export_mode_texts.complete_export_mode;					
				} else {
					restore_mode['development_package'] = multisite_migration_js_ajax_renderer.multisite_migration_export_mode_texts.development_package;				
				}				
			} else if (MultisiteMigrationCoreJSObject.searchInObject(media, zipfiles)) {
				restore_mode['db_and_media_export'] = multisite_migration_js_ajax_renderer.multisite_migration_export_mode_texts.db_and_media_export;
			} else {
				restore_mode['dbonly_export'] = multisite_migration_js_ajax_renderer.multisite_migration_export_mode_texts.dbonly_export;
			} 

			return restore_mode;   		
    	},
    	/**
    	 * Human readable filesize
    	 * Credits: https://stackoverflow.com/questions/10420352/converting-file-size-in-bytes-to-human-readable-string#answer-14919494
    	 */
    	humanFileSize: function (bytes, si) {
    	    var thresh = si ? 1000 : 1024;
    	    if(Math.abs(bytes) < thresh) {
    	        return bytes + ' B';
    	    }
    	    var units = si
    	        ? ['kB','MB','GB','TB','PB','EB','ZB','YB']
    	        : ['KiB','MiB','GiB','TiB','PiB','EiB','ZiB','YiB'];
    	    var u = -1;
    	    do {
    	        bytes /= thresh;
    	        ++u;
    	    } while(Math.abs(bytes) >= thresh && u < units.length - 1);
    	    return bytes.toFixed(1)+' '+units[u];
    	},
    	/**
    	 * Set dialog restore warning info
    	 */
    	setDialogWarningRestoreInfoText: function(target_selector, multisiteblog_id, restore_mode, encrypted, exported_mode_texts, site_title, source, packagesize, encrypted_media) {    		
    		var restoration_mode_selector = target_selector + ' .js-multisite-migration-warning-restoration-mode';
    		var restoration_blog_id = target_selector + ' .js-multisite-migration-warning-target-blog-id';
    		var restoration_site_title = target_selector + ' .js-multisite-migration-warning-target-site-title';
    		var restoration_source_origin = target_selector + ' .js-multisite-migration-warning-source-of-origin';
    		
    		var restoration_encrypted_status = target_selector + ' .js-multisite-migration-warning-restoring-encrypted';
    		var restoration_encrypted_note = target_selector + ' .js-multisite-migration-encrypted-package-note';
    		var exported_texts_selector = target_selector + ' .js-multisite-migration-warning-scope-mode';
    		
    		var restoration_encrypted_media_status = target_selector + ' .js-prime-mover-encrypted-media';
    		var exported_texts_selector = target_selector + ' .js-multisite-migration-warning-scope-mode';
    		var restoration_packagesize_selector = target_selector + ' .js-prime-mover-package-size-dialog';
    		var encrypted_media_li = target_selector + ' #js-restoration-encrypted-mediafiles-prime-mover';
    			
    		$(restoration_encrypted_status).html(multisite_migration_js_ajax_renderer.multisite_migration_restore_noencryption_warning);
    		$(restoration_encrypted_media_status).html(multisite_migration_js_ajax_renderer.multisite_migration_restore_noencryption_warning);
    		var restore_mode_slug = '';
    		var export_mode_description = ''
    		for(var key in exported_mode_texts) {
    			restore_mode_slug = key;
    			export_mode_description = exported_mode_texts[restore_mode_slug];  			
    		}
    		$(encrypted_media_li).hide(); 
            if ('complete_export_mode' === restore_mode_slug || 'db_and_media_export' === restore_mode_slug) {
            	$(encrypted_media_li).show();         	
            }                        
    		$(exported_texts_selector).html(export_mode_description);
    		$(restoration_encrypted_note).html('');   		
    		$(restoration_packagesize_selector).html(packagesize);
    		
			if (true === encrypted) {
				$(restoration_encrypted_status).html(multisite_migration_js_ajax_renderer.multisite_migration_restore_encrypted_package_warning);  
				$(restoration_encrypted_note).html(multisite_migration_js_ajax_renderer.multisite_migration_encrypted_note);  
			} 
            if (true === encrypted_media) {
            	$(restoration_encrypted_media_status).html(multisite_migration_js_ajax_renderer.multisite_migration_restore_encrypted_package_warning); 
            }
    		if ('restore_within_server' === restore_mode) {
    			$(restoration_mode_selector).html(multisite_migration_js_ajax_renderer.multisite_migration_restorewithinserver_mode);    			
    		} else if ('restore_from_remote_url' === restore_mode) {    			
    			$(restoration_mode_selector).html(multisite_migration_js_ajax_renderer.multisite_migration_restore_remote_url_mode);  			
    		} else {
    			$(restoration_mode_selector).html(multisite_migration_js_ajax_renderer.multisite_migration_upload_package_mode); 
    		}
    		if (restoration_blog_id.length) {
    			$(restoration_blog_id).html(multisiteblog_id);     			
    		}
    		$(restoration_site_title).html(site_title);  
    		$(restoration_source_origin).html(source);  
    	},    	
    	/**
    	 * General import warning dialog
    	 */
    	generalImportWarningDialog: function(multisiteblog_id, the_import_package, gearbox_call, restore_path, restore_mode, encrypted, exported_mode_texts, site_title, source, packagesize, encrypted_media) {
            if (typeof(gearbox_call) === 'undefined') {
            	var gearbox_call = false;
            } 
            if (typeof(restore_path) === 'undefined') {
            	var restore_path = null;
            }
            if (typeof(restore_mode) === 'undefined') {
            	var restore_mode = null;
            } 
            if (typeof(encrypted) === 'undefined') {
            	var encrypted = null;
            }
            if (typeof(exported_mode_texts) === 'undefined') {
            	var exported_mode_texts = [];
            } 
            if (typeof(site_title) === 'undefined') {
            	var site_title = null;
            } 
            if (typeof(source) === 'undefined') {
            	var source = null;
            }
            if (typeof(packagesize) === 'undefined') {
            	var packagesize = null;
            } 
            if (typeof(encrypted_media) === 'undefined') {
            	var encrypted_media = false;
            } 
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'General Import warning triggered.', 'import', 'generalImportWarningDialog');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Import package: ' + the_import_package, 'import', 'generalImportWarningDialog');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Gearbox call: ' + gearbox_call, 'import', 'generalImportWarningDialog');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Restore path: ' + restore_path, 'import', 'generalImportWarningDialog');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Restore mode: ' + restore_mode, 'import', 'generalImportWarningDialog');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Site title: ' + site_title, 'import', 'generalImportWarningDialog');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Source: ' + source, 'import', 'generalImportWarningDialog');
            
            var target_selector = "#js-multisite-migration-import-warning-confirm-" + multisiteblog_id;
            var dialog_selector = $(target_selector);
            var data = $(dialog_selector).data();            
            
            if ( ! packagesize ) {            	
            	var packagesize = the_import_package.size;  
            	packagesize = this.humanFileSize(packagesize, true);
            }             
            	
            data.gearbox_call = gearbox_call;
            data.restore_path = restore_path;
            data.restore_mode = restore_mode;
            
            MultisiteMigrationCoreJSObject.setDialogWarningRestoreInfoText(target_selector, multisiteblog_id, restore_mode, encrypted, exported_mode_texts, site_title, source, packagesize, encrypted_media);            
			$(dialog_selector).dialog({
	            resizable: false,
	            height: "auto",
	            width: "auto",
	            maxWidth: 600,
	            modal: true,
	            fluid: true,	            
				buttons: [
				    {
				      text: multisite_migration_js_ajax_renderer.yes_button,	
				      "class": 'button-primary',
				      click: function() {
		            	  $( this ).dialog( "close" );
		            	  var gearbox_called = $(this).data('gearbox_call');
		            	  if (gearbox_called) {
		            		  var args = {import_restorepath:restore_path};	            		  
		            		  MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Gearbox same site server restoration and user confirms warning', 'import', 'generalImportWarningDialog');	            		  
		            		  MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, 'import', 'generalImportWarningDialog');
		            		  
		            		  MultisiteMigrationCoreJSObject.initiateSpinner(multisiteblog_id);
		            		  MultisiteMigrationCoreJSObject.multisite_migration_track_progress('import', multisiteblog_id, false, args);
		            	  } else {	        
		            		  MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Core upload support and user confirms warning, firing import handler.', 'import', 'generalImportWarningDialog');	            		  
		            		  
		            		  var args = {import_package_upload: the_import_package};
		            		  MultisiteMigrationCoreJSObject.initiateSpinner(multisiteblog_id);
		            		  MultisiteMigrationCoreJSObject.multisite_migration_track_progress('import', multisiteblog_id, false, args);
		            	  }				           	  
					   }
				    },
				    {
					 text: multisite_migration_js_ajax_renderer.cancel_button,					 
					 click: function() {
						  var dialog_object = this;
						  $(dialog_object).dialog( "close" );	
						  MultisiteMigrationCoreJSObject.doWhenImportWarningIsCancelled(multisiteblog_id, dialog_object, restore_mode, restore_path);
					  }
					},				    
				 ],
 		         create: function() {
 		        	  var dialog_object = this;
 		              $(dialog_object).closest('div.ui-dialog')
 		                     .find('.ui-dialog-titlebar-close')
 		                     .click(function(e) {	
 		                    	  restore_mode = $(dialog_object).data('restore_mode');
 		                    	  restore_path = $(dialog_object).data('restore_path');
 								  MultisiteMigrationCoreJSObject.doWhenImportWarningIsCancelled(multisiteblog_id, dialog_object, restore_mode, restore_path); 		                        
 		                     });
 		        }				 
	          });
		      MultisiteMigrationCoreJSObject.handle_responsive_dialog();   		
    	},
    	/**
    	 * Do when import warning is cancelled
    	 */
    	doWhenImportWarningIsCancelled: function(multisiteblog_id, dialog_object, restore_mode, restore_path) {    		
    	    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'User does not want to confirm import warning, cancelled.', 'import', 'generalImportWarningDialog');
    	    
    	    var gearbox_called = $(dialog_object).data('gearbox_call');
    	    if ( gearbox_called && 'restore_from_remote_url' === restore_mode) {
    		    MultisiteMigrationCoreJSObject.requestToDeleteTmpFile(restore_path, multisiteblog_id, false);
    	    }
    	    MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id, true, 'import', true );
    	    MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);    	    
    	},    	
    	/**
    	 * Lock and unlock buttons that is currently running a process
    	 */
    	lockDownButtons: function(multisiteblog_id, lock) {
    		if ( ! multisiteblog_id ) {
    			return;
    		}
    		
            if (typeof(lock) === 'undefined') {
            	var lock = true;
            }
            
            var export_button = '#js-multisite_migration_exporting_blog_' + multisiteblog_id;
            var import_button = '#js-multisite_migration_importing_blog_' + multisiteblog_id;
            var gearbox_restore_button = '#js-multisite_migration_restorebackup_' + multisiteblog_id;            
            var upload_label = '#js-multisite-migration-browseupload-label-' + multisiteblog_id;            
            
            
            var canBeDisabledSelectors = [
            	export_button,
            	import_button,
            	gearbox_restore_button
            ];
            
            var arrayLength = canBeDisabledSelectors.length;
            for (var i = 0; i < arrayLength; i++) {
                var processed = canBeDisabledSelectors[i];
                
                if ($(processed).length ) {
                	if (lock) {
                		$(processed).prop('disabled', true);           		
                	} else {
                		$(processed).prop('disabled', false);          		
                	}            	
                }               
            }        
            
            if ($(upload_label).length ) {
            	if (lock) {
            		$(upload_label).addClass('disabled');     		
            	} else {
            		$(upload_label).removeClass('disabled');        		
            	}            	
            }    		
    	},
    	/**
    	 * Request export
    	 */
    	doExport: function() {
    		var export_column = '.js-multisite-migration-sites-page';
    		$(export_column).on('click','input.js-multisite_migration_exportbutton', function(){ 
    			/**
    			 * Here we have an export click event
    			 */		
    			/** Attempt to get the blog ID to export */
    			var multisiteblog_id = $(this).attr("data-multisiteblogid");		

				$( "#js-multisite-migration-export-dialog-confirm-" + multisiteblog_id ).dialog({
		            resizable: false,
		            height: "auto",
		            width: "auto",
		            maxWidth: 600,
		            modal: true,
		            fluid: true,
					buttons: [
					    {
					      text: multisite_migration_js_ajax_renderer.export_now_button,	
					      "class": 'js-multisite-migration-export-now-button button-primary',
					      click: function() {
				           	  $( this ).dialog( "close" );
								var export_option = $('input[name=multisite-migration-export-mode-' + multisiteblog_id + ']:checked').val();
								if ( export_option ) {
								    MultisiteMigrationCoreJSObject.multisite_migration_exporter( export_option, multisiteblog_id );
								}			           	  
						      }
					    },
					    {
						 text: multisite_migration_js_ajax_renderer.cancel_button,					 
						 click: function() {
							 $( this ).dialog( "close" );
						  }
						},				    
					 ],
					 close: function( event, ui ) {
						 MultisiteMigrationCoreJSObject.hideClipBoardButton(multisiteblog_id);
						 $('#js-multisite_migration_exporting_blog_' + multisiteblog_id).removeClass('button');
						 $('#js-multisite_migration_exporting_blog_' + multisiteblog_id).addClass('button-primary');
					 },
					 open: function( event, ui ) {    						 
						 $('#js-multisite_export_span_'+ multisiteblog_id ).html('');
						 MultisiteMigrationCoreJSObject.cleanProgressSpans(multisiteblog_id, 'export');
						 $('#js-multisite_migration_exporting_blog_' + multisiteblog_id).removeClass('button-primary');
						 $('#js-multisite_migration_exporting_blog_' + multisiteblog_id).addClass('button');						 
						 
				    	 if( $("#js-multisite-migration-export-targetid").length){ 				    			 
				    		$("#js-multisite-migration-export-targetid").val('');	
				    	 }	

				    	 if( $('.js-multisite-migration-export-as-multisite').length){ 				    			 
				    		 $('.js-multisite-migration-export-as-multisite').prop('checked', false);
					     }
				    	 
				    	 if( $("#js-prime-mover-export-to-multisite-div-1").length){
				    		 $("#js-prime-mover-export-to-multisite-div-1").hide();
				    	 }			    	 
					 }
			        });
			  MultisiteMigrationCoreJSObject.handle_responsive_dialog();	


    		});    		
    	},
    	/**
    	 * Hide clipboard button if applicable
    	 */
    	hideClipBoardButton: function (multisiteblog_id) {
    		var clipboardbutton = "#js-multisite-migration-copy-url-clipboard-" + multisiteblog_id;
    		if( ! $(clipboardbutton).length){
    			return;
    		}
    		$(clipboardbutton).hide();
    	},
    	/**
    	 * Generate refresh ID
    	 */
    	generateRefreshID: function ( mode, multisiteblog_id ) {
    		var refreshid = mode + '_refreshID_' + multisiteblog_id;
    		return refreshid;
    	},
    	/**
    	 * Checks if refresh ID is set
    	 */
    	isRefreshIDSet: function(refreshid) {
    		if(MultisiteMigrationCoreJSObject.hasOwnProperty(refreshid)){
    		    return true;
    		} else {
    			return false;
    		}    		
    	},
    	/**
    	 * Do boot actions
    	 */
    	doBootActions: function(mode, multisiteblog_id, args) {
    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Doing boot actions..', mode, 'doBootActions');
    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, mode, 'doBootActions');
    		if ('import_restorepath' in args && args.import_restorepath) { 
    			/**
    			 * Gearbox within server restoration
    			 */
    			MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, true);
			    var restore_path = args.import_restorepath;
			    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Restore path: ' + restore_path, mode, 'doBootActions');
    		    
			    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Gearbox called and user confirms warning, firing import handler.', 'import', 'doBootActions');
			    MultisiteMigrationCoreJSObject.import_handler( multisiteblog_id, restore_path );  			
    		} else if (args instanceof FormData) {
    			/**
    			 * Diff processing
    			 */
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Continue diff processing...', mode, 'doBootActions');   
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, mode, 'doBootActions');
    	        $.ajax({
    	            url: ajaxurl,
    	            type: 'post',			 			            
    	            data: args,
    	            cache: false,	
    	            contentType: false,            
    	            processData: false,
    	            success: function( response ) {		 	    	 		 	    	 				                
    	            }
    	        });    			
    		} else if ('import_package_upload' in args) {
    			/**
    			 * Core restore support (upload)
    			 */
    			MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, true);
    			var the_import_package = args.import_package_upload;
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Core import package upload triggered after boot.', 'import', 'doBootActions');
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, the_import_package, 'import', 'doBootActions');    			
    			
    			MultisiteMigrationCoreJSObject.user_confirms_import_to_proceed( multisiteblog_id, the_import_package );
    		} else if ('multisite_migration_export_nonce' in args) {
    			/**
    			 * Core export support
    			 */
    			MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, true);
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Core export support requested after boot', 'export', 'doBootActions');
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, 'import', 'doBootActions');
    			MultisiteMigrationCoreJSObject.doExporterAjax(multisiteblog_id, args);
    		} else if ('import_package_url' in args) {
    			/**
    			 * Restore from remote URL gearbox support
    			 */
    			MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, true);
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Gearbox restore from remote URL requested after boot', 'export', 'doBootActions');
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, 'import', 'doBootActions');
			    
			    var package_url = args.import_package_url;				    			     			  
			    MultisiteMigrationCoreJSObject.fetchFileToRestore(package_url, multisiteblog_id);
    		}
    	},
    	/**
    	 * Fetch file to restore
    	 */
    	fetchFileToRestore: function(package_url, multisiteblog_id) {
		  var data = {
			    action: 'multisite_migration_download_remote_url',
			   	dataType: 'json',	 
			   	package_url: package_url,
			   	multisite_migration_downloadfile_nonce: multisite_migration_js_ajax_renderer.multisite_migration_downloadfile_nonce,
			   	multisiteblog_id: multisiteblog_id
			      };		

	        $.ajax({
	            url: multisite_migration_js_ajax_renderer.ajaxurl,
	            type: 'post',		 			            
	            data: data, 
	            retryLimit: multisite_migration_js_ajax_renderer.multisite_migration_retry_limit,
	            tryCount : 0,
	            success: function( response ) {		 	    	 		 	    	 				            	
	            },
	            error : function(xhr, textStatus, errorThrown ) {
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'FetchFilesRestore failed detected, error thrown is ' + errorThrown, 'import', 'fetchFileToRestore');
	            	
		            var refreshid =  MultisiteMigrationCoreJSObject.generateRefreshID('import', multisiteblog_id);
		            var progress_identifier =  MultisiteMigrationCoreJSObject.generateProgressIdentifier(refreshid, 'import');	            
		            var in_progress = false;
		            var retry = false;
		            
		            if (typeof MultisiteMigrationCoreJSObject[progress_identifier] !== 'undefined') {
		            	var latest_progress = MultisiteMigrationCoreJSObject[progress_identifier];
		            	if (latest_progress) {
		            		in_progress = true;
		            	}
		            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Latest progress fetch file to restore check: ' + latest_progress, 'import', 'fetchFileToRestore');
		            } 
	                if ( ! in_progress ) {
	                	retry = true;
	                }
	                
	                MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'FetchFilesRestore failed detected, retry status is ' + retry, 'import', 'fetchFileToRestore');
		 		    var ajax_handler_object = this;
		   	 	    MultisiteMigrationCoreJSObject.doErrorHandling(multisiteblog_id, 'import', ajax_handler_object, null, retry, 'fetchFileToRestore');	            	
	            } 
	        });		 	  	 	  
    	},   	
    	/**
    	 * Generate Progress Identifier
    	 */
    	generateProgressIdentifier: function(refreshid, mode ) {
    		return mode + '_' + refreshid; 		
    	},
    	/**
    	 * Do status actions
    	 */
    	doStatusActions: function(status, refreshid, mode, response, multisiteblog_id, pulse) {
    	 	if (status) {	 	    	 		
    	 		if ( 'stoptracking' === status ) {		
 	                if ( false === MultisiteMigrationCoreJSObject[refreshid] ) {
 	        			return;
 	        		}
 	        		clearTimeout(MultisiteMigrationCoreJSObject[refreshid]);
 	        		MultisiteMigrationCoreJSObject[refreshid] = false; 	
 	        		pulse = false;
    	 			if ( 'import' === mode ) {
    	 				MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Import stop tracking detected, processing import result handler', mode, 'doStatusActions'); 
    	 				MultisiteMigrationCoreJSObject.import_result_handler( multisiteblog_id, response.import_result);
    	 			} else {
    	 				MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Export stop tracking detected, processing export success handler', mode, 'doStatusActions');
    	 				MultisiteMigrationCoreJSObject.export_success_handler( multisiteblog_id, response.export_result);
    	 			}
    	 			MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
    	 		} else if ('diffdetected' === status) {
 	           		if ( false === MultisiteMigrationCoreJSObject[refreshid] ) {
 	        			return;
 	        		}
 	        		clearTimeout(MultisiteMigrationCoreJSObject[refreshid]);	
 	        		MultisiteMigrationCoreJSObject[refreshid] = false;
 	        		pulse = false;
    	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Diff detected, processing import result handler diff processor', mode, 'doStatusActions');
    	 			MultisiteMigrationCoreJSObject.import_result_handler( multisiteblog_id, response.import_result);
    	 		} else if ('package_downloaded' === status) {	
 	           		if ( false === MultisiteMigrationCoreJSObject[refreshid] ) {
 	        			return;
 	        		}
 	        		clearTimeout(MultisiteMigrationCoreJSObject[refreshid]);	
 	        		MultisiteMigrationCoreJSObject[refreshid] = false;
 	        		pulse = false;
    	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Package downloaded detected processing download success handler', mode, 'doStatusActions');
    		 		MultisiteMigrationCoreJSObject.download_success_handler( multisiteblog_id, response.download_result);
    	 		} else if ('downloading_package' === status) {
 	           		if ( false === MultisiteMigrationCoreJSObject[refreshid] ) {
 	        			return;
 	        		} 	           	    
    	 			if ('total_download_size' in response && 'ongoing_size' in response) {
    	 				var progress_span_selector = '#js-multisite_import_progress_span_'+ multisiteblog_id;
    	 				$(progress_span_selector).html( multisite_migration_js_ajax_renderer.multisite_migration_downloading_progress_text + '..<progress></progress>' );     	 				;
                        $(progress_span_selector + ' progress').attr({
                            value: response.ongoing_size,
                            max: response.total_download_size,
                        });   	 				
    	 			}  	 			 
    	 		} else if ('uploading_to_dropbox' === status) {
 	           		if ( false === MultisiteMigrationCoreJSObject[refreshid] ) {
 	        			return;
 	        		} 	           	    
    	 			if ('total_upload_size' in response && 'ongoing_size' in response) {
    	 				var progress_span_selector = '#js-multisite_export_progress_span_'+ multisiteblog_id;
    	 				$(progress_span_selector).html( multisite_migration_js_ajax_renderer.multisite_migration_dropbox_upload_progress_text + '..<progress></progress>' );     	 				;
                        $(progress_span_selector + ' progress').attr({
                            value: response.ongoing_size,
                            max: response.total_upload_size,
                        });   	 				
    	 			}  	 			 
    	 		} else {
 	           		if ( false === MultisiteMigrationCoreJSObject[refreshid] ) {
 	        			return;
 	        		} 	           	    
    	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Ongoing status: ' + status, mode, 'doStatusActions');
    	 			var progress_selector = '#js-multisite_' + mode + '_progress_span_'+ multisiteblog_id;
    	 			if ('boot' !== status) {
    	 				$(progress_selector).text(status);   	 				
    	 			}    	 			
    	 		}
    	 } else if (response.logexist && response.error_msg ) {
         		if ( false === MultisiteMigrationCoreJSObject[refreshid] ) {
	        	    return;
	        	}	 	    		
 	    		clearTimeout(MultisiteMigrationCoreJSObject[refreshid]);
	        	MultisiteMigrationCoreJSObject[refreshid] = false;
	        	pulse = false;
	        	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Fatal runtime errors found during progress status check, aborting..', mode, 'doStatusActions');
	        	MultisiteMigrationCoreJSObject.displayRunTimeError(multisiteblog_id, mode, 'doStatusActions', response);	        	
	    } else {
    	     MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Status not defined:' + status, mode, 'doStatusActions');
    	}   
    	
    	 	return pulse;
    	},
    	/**
    	 * Progress AJAX
    	 */
    	progressAjax: function(data, mode, multisiteblog_id, progress_identifier, refreshid, args) {    		 		
            if (typeof(args) === 'undefined') {
            	var args = {};
            }
	        $.ajax({
	            url: multisite_migration_js_ajax_renderer.ajaxurl,
	            type: 'post',		 			            
	            data: data,
	            retryLimit : multisite_migration_js_ajax_renderer.multisite_migration_retry_limit,
	            success: function( response ) {	
	            	data.trackercount++; 
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Generic success response received for progress ajax.', mode, 'progressAjax');
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, response, mode, 'progressAjax');
	 	    	 	if ( 'import' === mode ) {
	 	    	 		var status = response.import_status;
	 	    	 	} else {
	 	    	 		var status = response.export_status;
	 	    	 	}	
	 	    	 	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Progress identifier is: ' + progress_identifier , mode, 'progressAjax');
	 	    	 	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Progress identifier status is: ' + status , mode, 'progressAjax');
	 	    	 	MultisiteMigrationCoreJSObject[progress_identifier] = status;
	 	    	 	var pulse = true;
	 	    	 	
	 	    	 	if ('bootup' in response && response.bootup) {
	 	    	 		MultisiteMigrationCoreJSObject[progress_identifier] = 'boot';
	 	    	 		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Bootup Response', mode, 'progressAjax');
	 	    	 		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, mode, 'progressAjax');	 	    	 		
	 	    	 		MultisiteMigrationCoreJSObject.doBootActions(mode, multisiteblog_id, args);
	 	    	 	} else {
	 	    	 		pulse = MultisiteMigrationCoreJSObject.doStatusActions(status, refreshid, mode, response, multisiteblog_id, pulse);
	 	    	 	}	 
	 	    	 	if (pulse) {
	 	    	 		MultisiteMigrationCoreJSObject[refreshid] = setTimeout(function() { MultisiteMigrationCoreJSObject.progressAjax(data, mode, multisiteblog_id, progress_identifier, refreshid); }, 2000);	 	    	 		
	 	    	 	}
	            },
	            error : function(xhr, textStatus, errorThrown ) {
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Error detected on ajax track progress request, error thrown is ' + errorThrown , mode, 'progressAjax'); 
                    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Progress failed request detected, retrying again.', mode, 'progressAjax'); 

            	    if ( ! errorThrown) {
            	    	errorThrown = multisite_migration_js_ajax_renderer.multisite_migration_unknown_js_error;
            	    }
	    	    	 data.errorcount++;
	            	 var msg = multisite_migration_js_ajax_renderer.multisite_migration_progress_error_message;
	    			 msg = msg.replace('{{PROGRESSSERVERERROR}}', errorThrown);
	    			 msg = msg.replace('{{BLOGID}}', multisiteblog_id);
	
	        	     clearprogressspans = true;	 
	                 if (data.errorcount <= this.retryLimit) {
	
	                	 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'The progress ajax request has been retried.', mode, 'progressAjax');
	             		 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Current try count: ' + data.errorcount, mode, 'progressAjax');
	             		 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Retry limit: ' + this.retryLimit, mode, 'progressAjax');
	             		 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Arguments passed to progress re-sending:', mode, 'progressAjax');
	             		 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, mode, 'progressAjax');
	             		 MultisiteMigrationCoreJSObject[refreshid] = setTimeout(function() { MultisiteMigrationCoreJSObject.progressAjax(data, mode, multisiteblog_id, progress_identifier, refreshid, args); }, 2000);   	                         
	             		 
	                 } else if ( data.errorcount > this.retryLimit ) {
	                	 
	                	 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'The progress ajax request has reached a retry limit.', mode, 'progressAjax');
	             		 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Limit try count: ' + data.errorcount, mode, 'progressAjax');
	             		 MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Retry limit: ' + this.retryLimit, mode, 'progressAjax');
	             		 
	                 	 MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id, true, mode, true );
	                 	 var uploaderror_selector = MultisiteMigrationCoreJSObject.getGenericFailSelector(multisiteblog_id);
	                 	 if ( false === MultisiteMigrationCoreJSObject.dialogIsOpen(uploaderror_selector, true) ) {               			              		
	                 		MultisiteMigrationCoreJSObject.user_notices( uploaderror_selector, multisiteblog_id, mode, clearprogressspans, msg );
	                 	}
	                 	MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
	                 }	            	    
            	    
	            } 
	        });	  		
    	},
    	/**
    	 * Track import/export progress
    	 */
    	multisite_migration_track_progress: function( mode, multisiteblog_id, diffmode, args) {
            if (typeof(mode) === 'undefined') {
            	var mode = 'import';
            }
            if (typeof(diffmode) === 'undefined') {
            	var diffmode = false;
            } 
            if (typeof(args) === 'undefined') {
            	var args = {};
            }
            var refreshid = this.generateRefreshID(mode, multisiteblog_id);
            var progress_identifier = this.generateProgressIdentifier(refreshid, mode);          			
            
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Progress tracking requested with the following parameters', mode, 'multisite_migration_track_progress');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Blog ID: ' + multisiteblog_id, mode, 'multisite_migration_track_progress');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Mode: ' + mode, mode, 'multisite_migration_track_progress');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Refresh ID: ' + refreshid, mode, 'multisite_migration_track_progress');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Progress Identifier: ' + progress_identifier, mode, 'multisite_migration_track_progress');
            
            var data = {
	      			action: 'multisite_migration_monitor_' + mode +  '_progress',
	   				dataType: 'json',	 
	   				blog_id : multisiteblog_id		   				 			 		    				    					
	    	};	
		    
			if ( 'import' === mode ) {
				data.multisite_migration_import_progress_nonce = multisite_migration_js_ajax_renderer.multisite_migration_import_progress_nonce;
			} else {    			
				data.multisite_migration_export_progress_nonce = multisite_migration_js_ajax_renderer.multisite_migration_export_progress_nonce;
			}
			
			data.trackercount = 1;
			data.errorcount = 0;
			data.diffmode = diffmode;
			
			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Progress triggered, starting progress ajax...', mode, 'multisite_migration_track_progress'); 
			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, args, mode, 'multisite_migration_track_progress'); 
			
			this.progressAjax(data, mode, multisiteblog_id, progress_identifier, refreshid, args);        
    	},
    	/**
    	 * Do a clean shutdown of export and import processes AFTER FINAL RESULT is delivered to the client browser
    	 */
    	shutdown_process: function(mode, process_id, blog_id) {
		    var data = {
	      			action: 'multisite_migration_shutdown_' + mode +  '_process',
	   				dataType: 'json',	 
	   				process_id : process_id,
	   				blog_id: blog_id
	    	};
		    
			if ( 'import' === mode ) {
				data.multisite_migration_import_shutdown_nonce = multisite_migration_js_ajax_renderer.multisite_migration_import_shutdown_nonce;
			} else {    			
				data.multisite_migration_export_shutdown_nonce = multisite_migration_js_ajax_renderer.multisite_migration_export_shutdown_nonce;
			}
			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(blog_id, mode + ' shutdown started ajax request for' + process_id, mode, 'shutdown_process'); 
	        $.ajax({
	            url: multisite_migration_js_ajax_renderer.ajaxurl,
	            type: 'post',		 			            
	            data: data,
	            retryLimit : multisite_migration_js_ajax_renderer.multisite_migration_retry_limit,
	            tryCount : 0,
	            success: function( response ) {
	            	if ( 'status' in response ) { 
	            		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(blog_id, 'Response received: ' + response.status, mode, 'shutdown_process');	            		
	            	} else {
	            		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(blog_id, 'Empty response received', mode, 'shutdown_process');	
	            	}	            	
	            },
	            error : function(xhr, textStatus, errorThrown ) {
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Error dected on shutdown request, error thrown is ' + errorThrown , mode, 'shutdown_process'); 
                    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Retrying the shutdown request...', mode, 'shutdown_process'); 
                     
                    var ajax_handler_object = this;	
                    MultisiteMigrationCoreJSObject.doErrorHandling( multisiteblog_id, mode, ajax_handler_object, null, true, 'shutdown_process');			            	
	            } 
	        });	 		
    	},
    	/**
    	 * Import result handler
    	 */
    	import_result_handler: function(multisiteblog_id, response) {
    	 	var myObj_multisite_migration_import_status = response;			 	    	 				 	    	 	
 	    	if ( true  === myObj_multisite_migration_import_status.status ) {	
 	    		//Import success		 	    		
 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Import success detected. Clearing intervals.', 'import', 'import_result_handler');
 	    		MultisiteMigrationCoreJSObject.import_success_handler( multisiteblog_id, myObj_multisite_migration_import_status );
 	    		MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id, false ); 	    		
	
 	    		if ('process_id' in myObj_multisite_migration_import_status) {
 	 	    		var process_id = myObj_multisite_migration_import_status.process_id;
 	 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Import shutdown requested to server for process id' + process_id, 'import', 'import_result_handler');  	    		
 	 	    		
 	 	    		MultisiteMigrationCoreJSObject.shutdown_process('import', process_id, multisiteblog_id);  	    			
 	    		} 	    		
 	    	} else if ( true === myObj_multisite_migration_import_status.diff_detected ) {
 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Diff processed.', 'import', 'import_result_handler');
 	    		MultisiteMigrationCoreJSObject.shutdown_process('import', myObj_multisite_migration_import_status.process_id, multisiteblog_id);
 	    		var import_diff_selector = "#js-multisite-migration-import-diff-confirm-" + multisiteblog_id;
 	    		$( import_diff_selector ).html( myObj_multisite_migration_import_status.diff );
 	    		
 	            var data = $(import_diff_selector).data(); 	            
 	            data.myObj_multisite_migration_import_status = myObj_multisite_migration_import_status; 	            
 				$( import_diff_selector ).dialog({
 		            resizable: false,
 		            height: 600,
 		            width: "auto",
 		            maxWidth: 600,
 		            modal: true,
 		            fluid: true,  
					buttons: [
					    {
					      text: multisite_migration_js_ajax_renderer.yes_button,	
					      "class": 'button-primary',
					      click: function() {
	 		            	  $( this ).dialog( "close" );
	 		            	  $( import_diff_selector ).text('');
	 		            	  MultisiteMigrationCoreJSObject.user_approves_diff( myObj_multisite_migration_import_status, multisiteblog_id );			           	  
						      }
					    },
					    {
						 text: multisite_migration_js_ajax_renderer.no_button,					 
						 click: function() {
	 		            	  $( this ).dialog( "close" );
	 		            	  MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
	 		            	  MultisiteMigrationCoreJSObject.doAfterClose( import_diff_selector, myObj_multisite_migration_import_status, multisiteblog_id );
						  }
						},				    
					 ],	 		        
	 		       create: function() {
	 		            $(this).closest('div.ui-dialog')
	 		                   .find('.ui-dialog-titlebar-close')
	 		                   .click(function(e) {	
	 		                	  myObj_multisite_migration_import_status = data.myObj_multisite_migration_import_status;
			 		              MultisiteMigrationCoreJSObject.doAfterClose( import_diff_selector, myObj_multisite_migration_import_status, multisiteblog_id );
			 		             MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
	 		                      e.preventDefault();
	 		                   });
	 		        }
 		          });
 			  MultisiteMigrationCoreJSObject.handle_responsive_dialog();	
 				
 	    	} else {
 	    		//Import unsuccessful, display error			 	    		
 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).html( myObj_multisite_migration_import_status.import_not_successful );
 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).css( 'color', 'red' );
 	    		
 	    		MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id );
 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).css( 'width', '100%' );
 	    		
 	    		var process_id = myObj_multisite_migration_import_status.process_id;
 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Error occurred and Import shutdown requested to server for process id' + process_id, 'import', 'import_result_handler');  	    		
 	    		
 	    		MultisiteMigrationCoreJSObject.shutdown_process('import', process_id, multisiteblog_id); 
 	    	}    		
    	},
    	/**
    	 * Download success handler
    	 */
    	download_success_handler: function(multisiteblog_id, response) {    		
	 		 if (response.download_status) {		 	    	
	 			
	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response download status defined, value is ' + response.download_status, 'import', 'download_success_handler');
	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response package encrypted status, value is ' + response.encrypted, 'import', 'download_success_handler');
	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response package description type, value is ' + response.package_description, 'import', 'download_success_handler');
	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response message, value is ' + response.message, 'import', 'download_success_handler');
	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response site title value is ' + response.site_title, 'import', 'download_success_handler');
	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response download URL value is ' + response.source, 'import', 'download_success_handler');
	 			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response download package size is ' + response.package_size, 'import', 'download_success_handler');
	 			
	 			var wrongselector = '#js-multisite-migration-wrong-importedsite-' + multisiteblog_id;
	 			if (response.package_description) {
	 				if (response.encrypted && 'can_decrypt' in response && 'decryption_error' in response && ! response.can_decrypt) {
						MultisiteMigrationCoreJSObject.user_notices(wrongselector, multisiteblog_id, 'import', true, response.decryption_error);
						MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);	 					
	 				} else if (response.encrypted_media && 'can_decrypt_media' in response && ! response.can_decrypt_media) {
						MultisiteMigrationCoreJSObject.user_notices(wrongselector, multisiteblog_id, 'import', true, multisite_migration_js_ajax_renderer.prime_mover_media_decryption_error);
						MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);	 					
	 				} else {	 					
	 					/** response.package_description is an array */
		 				MultisiteMigrationCoreJSObject.generalImportWarningDialog(multisiteblog_id, '', true, response.message, 'restore_from_remote_url',
		 						response.encrypted, response.package_description, response.site_title, response.source, response.package_size, response.encrypted_media); 		 					
	 				} 				
	 			} else {			 		
	 				var error_message = multisite_migration_js_ajax_renderer.prime_mover_invalid_package;
	 				if ('decryption_error' in response) {
	 					error_message = response.decryption_error;
	 				}
					MultisiteMigrationCoreJSObject.user_notices(wrongselector, multisiteblog_id, 'import', true, error_message);
					MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
	 			}				
		     } else {
		    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Response download status is not defined.', 'import', 'download_success_handler');
		 	   	MultisiteMigrationCoreJSObject.import_failed_handler( multisiteblog_id, response.message );	 	    		
		 	   	
		 	   	MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id );
		 	   	$('#js-multisite_import_span_'+ multisiteblog_id ).css( 'width', '100%' ); 
		 	    MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
		 	 }	   		
	 		MultisiteMigrationCoreJSObject.shutdown_process('import', response.process_id, multisiteblog_id);
    	},
    	/**
    	 * Export success handler
    	 */
    	export_success_handler: function(multisiteblog_id, response) {    		
    	 	var myObj_multisite_migration_export_status = response;	 	    	 	
 	    	if ( true  === myObj_multisite_migration_export_status.status ) {	
 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Export final success clearing intervals.', 'export', 'export_success_handler');
 	    		MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id, true, 'export' );
 	    		$('#js-multisite_export_span_'+ multisiteblog_id ).html('');	 	    		
 	    		if ( 'download_link' in myObj_multisite_migration_export_status ) { 
 	    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Streaming download link.', 'export', 'export_success_handler');
				    var link = document.createElement('a');
				    link.href = myObj_multisite_migration_export_status.download_link;
					
				    link.download = 'export_package.zip';
				    document.body.appendChild(link);
				    link.click(); 	
				    $('#js-multisite_export_span_'+ multisiteblog_id ).html(multisite_migration_js_ajax_renderer.multisite_migration_export_downloaded);
 	    		} else {		 	    	
 	    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Showing download link.', 'export', 'export_success_handler');
 	    			$('#js-multisite_export_span_'+ multisiteblog_id ).html("<p style='margin-top:10px;'>" + myObj_multisite_migration_export_status.message + "</p>");
 	    			MultisiteMigrationCoreJSObject.showClipBoardButtonIfSupported(multisiteblog_id, myObj_multisite_migration_export_status.restore_url);
 	    		}
 	    	} else if ( 'export_not_successful' in myObj_multisite_migration_export_status ) {
 	 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Export not successful received:' + myObj_multisite_migration_export_status.export_not_successful, 'export', 'export_success_handler');
 	 	    		$('#js-multisite_export_span_'+ multisiteblog_id ).html( myObj_multisite_migration_export_status.export_not_successful );
 	 	    		$('#js-multisite_export_span_'+ multisiteblog_id ).css( 'color', 'red' );		 	    		
 	 	    		MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id, true, 'export'); 
 	 	    }
 	    	if ('process_id' in myObj_multisite_migration_export_status) {
 		    	var process_id = myObj_multisite_migration_export_status.process_id;
 		    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Export shutdown requested to server for process id' + process_id, 'export', 'export_success_handler');  
 	 	    	MultisiteMigrationCoreJSObject.shutdown_process('export', process_id, multisiteblog_id);	    		
 	    	}
    	},
    	/**
    	 * Set export location if overriden by extension
    	 */
    	multisite_migration_set_export_location: function( multisiteblog_id ) {
    		var export_location = 'default';
    		if( ! $(".js-multisite_migration_target_export_location_class").length){    			
    			return export_location;    			
    		}
    		var export_location_selector = 'input#js-multisite-migration-targetexportloc-' + multisiteblog_id;
			if ($(export_location_selector).is(':checked')) {
				export_location = 'export_directory';
			}
			return export_location;    		
    	},
    	/**
    	 * Set encryption options if set
    	 */
    	multisite_migration_set_encryption_option: function( multisiteblog_id ) {
    		var encryption = false;
    		if( ! $(".js-multisite-migration-encryptiondb_class").length){    			
    			return encryption;    			
    		}
    		var encryption_mode_selector = 'input#js-multisite-migration-encryptiondb-' + multisiteblog_id;
			if ($(encryption_mode_selector).is(':checked')) {
				encryption = true;
			}
			return encryption;    		
    	},
    	/**
    	 * Set dropbox export option if set
    	 */
    	multisite_migration_set_dropbox_option: function( multisiteblog_id ) {
    		var dropbox_upload = false;
    		if( ! $(".js-multisite_migration_dropbox_class").length){    			
    			return dropbox_upload;    			
    		}
    		var dropbox_selector = 'input#js-multisite-migration-savetodropbox-' + multisiteblog_id;
			if ($(dropbox_selector).is(':checked')) {
				dropbox_upload = true;
			}
			return dropbox_upload;    		
    	}, 
    	/**
    	 * Set export id for single site exports
    	 */
    	multisite_migration_get_targetexport_id: function(multisiteblog_id) {
    		var targetid = 0;
	    	if( ! $("#js-multisite-migration-export-targetid").length){    			
	    		var single_site_selector = 'input#js-multisite-migration-export-as-single-site-' + multisiteblog_id;
				if ($(single_site_selector).is(':checked')) {
					return 1;
				} else {
					return targetid;
				}  			
		    }
	    	var value = $("#js-multisite-migration-export-targetid").val();
	    	value = value.trim();  
	    	if ( ! value ) {
	    		value = 1;
	    	}
            if (value) 	{
            	return value;
            } 
            return targetid;    	
        },    	
    	/**
    	 * Export process
    	 */
    	multisite_migration_exporter: function ( export_option, multisiteblog_id ) {
    					
			/**
			 * Validated
			 */		
			//Spinner
			var html_ajax_loader='<img src="'+ multisite_migration_js_ajax_renderer.multisite_migration_ajax_ajax_loader_gif + '" />';
			
			//Export location
			var export_location = this.multisite_migration_set_export_location(multisiteblog_id);
			
			//Encryption support
			var encryption_on = this.multisite_migration_set_encryption_option(multisiteblog_id);
			
			//Dropbox upload support
			var dropbox_upload = this.multisite_migration_set_dropbox_option(multisiteblog_id);
			
			//Target blog ID (single site only)
			var targetexport_id = this.multisite_migration_get_targetexport_id(multisiteblog_id);
			
			$('#js-multisite_export_span_'+ multisiteblog_id ).html( html_ajax_loader );	
			//Formulate data to post to server
		    	var data = {
	      			action: 'multisite_migration_process_export',
	   				dataType: 'json',	   				
	 	    		multisite_migration_export_nonce: multisite_migration_js_ajax_renderer.multisite_migration_export_nonce,
	 		    	multisite_blogid_to_export: multisiteblog_id,
	 		    	multisite_export_options: export_option,
	 		    	multisite_export_location: export_location,
	 		    	multisite_migration_encrypt_db: encryption_on,
	 		    	multisite_migration_dropbox_upload: dropbox_upload,
	 		    	multisite_migration_export_targetid: targetexport_id
	    		};		    	
		    	MultisiteMigrationCoreJSObject.multisite_migration_track_progress('export', multisiteblog_id, false, data);   		    		
    	},
    	/**
    	 * Do export ajax call
    	 */
    	doExporterAjax: function(multisiteblog_id, data) {
	        //Do an ajax request 	
	 	     $.post( multisite_migration_js_ajax_renderer.ajaxurl, data, function( response ) {	 		 
	 	     }).fail(function(xhr, status, error) {
	 	    	var ajax_handler_object = this;	 	    	
	   	 	    MultisiteMigrationCoreJSObject.doErrorHandling( multisiteblog_id, 'export', ajax_handler_object, null, false, 'doExporterAjax' );
	 	     });    		
    	},
    	/**
    	 * Show clipboard button if supported
    	 */
    	showClipBoardButtonIfSupported: function(multisiteblog_id, restore_url) {
    		var clipboard_el = "#js-multisite-migration-copy-url-clipboard-" + multisiteblog_id;    		
    		if ( $(clipboard_el).length ) {    			
    			$(clipboard_el).show();
    			$(clipboard_el).attr('data-clipboard-text',restore_url);
    		}
    	},
    	/**
    	 * Get Blog ID from zip folder name
    	 */
    	getBlogIDfromFolderName: function (import_folder) {
    		if ( ! import_folder ) {
    			return false;
    		}
    		var notrailing = import_folder.replace(/\/$/, "");
    		var splitted = notrailing.split("_");
    		var lastItem = splitted.pop();
    		return Number(lastItem);    		
    	},
    	/**
    	 * Log Processing Error Analysis for debugging purposes
    	 * Enable this constant in wp-config.php
    	 * define('MULTISITE_MIGRATION_JS_ERROR_ANALYSIS', true);
    	 * Clear browser cache then retry the upload
    	 * Log is viewable in browser console
    	 */
    	logProcessingErrorAnalysis: function (multisiteblog_id, text, mode, source) {
            if (typeof(source) === 'undefined' || ! source) {
            	source = 'not defined';
            }
    		if (multisite_migration_js_ajax_renderer.multisite_migration_upload_error_analysis) {
    			if ( this.multisite_migration_is_js_object(text)) {
    				console.log(mode + ' log for BlogID ' + multisiteblog_id + ' Object result Functional Source: ' + source);
    				console.log(text);
    			} else {
    				console.log(mode + ' log for BlogID ' + multisiteblog_id + ': ' + text + ' Functional Source: ' + source);
    			}    			
    		}
    	},
    	/**
    	 * Get error selectors
    	 */
    	getErrorSelectors: function(mode) {
		    var selector = '#js-multisite_import_span_';
		    if ( 'export' === mode ) {
		    	selector = '#js-multisite_export_span_';		    	
		    }
		    return selector;
    	},
    	/**
    	 * Display Runtime errors
    	 */
    	displayRunTimeError: function(multisiteblog_id, handling_mode, source, myObj_errorlog) {
 	 		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Error handling found error log file.', handling_mode, source); 
 	 		var selector = this.getErrorSelectors(handling_mode);
	    	$( selector + multisiteblog_id ).html( myObj_errorlog.error_msg );
	    	$( selector + multisiteblog_id ).css( 'color', 'red' );
	    	if ( 'import' === handling_mode ) {
	    		MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id );
	    	}
	    	if ( 'export' === handling_mode ) {
	    		MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id, true, 'export' );
	    	}	 	    		
	    	$( selector + multisiteblog_id ).css( 'width', '100%' ); 
	    	MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
    	},
    	/**
    	 * Error handling for Multisite migration AJAX processes
    	 */
    	doErrorHandling: function( multisiteblog_id, mode, ajax_handler_object, errorselector, retry, source ) {
            if (typeof(ajax_handler_object) === 'undefined') {
            	ajax_handler_object = null;
            }
            if (typeof(errorselector) === 'undefined') {
            	errorselector = '';
            }
            if (typeof(retry ) === 'undefined') {
            	retry = true;
            }
            if (typeof(source ) === 'undefined') {
            	source = '';
            }
            var handling_mode = 'import';
		    var data = {
	      			action: 'multisite_migration_check_if_error_log_exist',
	   				dataType: 'json',			   				
	   				multisite_migration_errorlog_nonce: multisite_migration_js_ajax_renderer.multisite_migration_errorlog_nonce,
	   				error_blog_id: multisiteblog_id
	    	};				    
		    var selector = MultisiteMigrationCoreJSObject.getErrorSelectors(mode);
		    if ('export' === mode ) {
		    	handling_mode = 'export';
		    }
		    
 	 		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Starting doErrorHandling before ajax post.', handling_mode, source); 	 		
	        $.ajax({
	            url: ajaxurl,
	            type: 'post',			 			            
	            data: data,	
	            retryLimit : multisite_migration_js_ajax_renderer.multisite_migration_retry_limit,
	            tryCount : 0,
	            success: function( response ) {		 	    	 		 	    	 	
	 	    	 	var myObj_errorlog = response;
	 	    	 	if ( myObj_errorlog.logexist && myObj_errorlog.error_msg ) {
	 	    	 		MultisiteMigrationCoreJSObject.displayRunTimeError(multisiteblog_id, handling_mode, source, myObj_errorlog);
	 	    	 	} else if (ajax_handler_object) {	
	 	    	 		if (retry) {
	 	    	 		    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'No error log file, we are retrying the ajax ' + handling_mode + ' request.', handling_mode, source);	
		 	    	 		MultisiteMigrationCoreJSObject.retryAjaxHandler(ajax_handler_object, handling_mode, multisiteblog_id);	 	    	 			
	 	    	 		} 	    	 	  	    	 		
	 	    	 	} else if (errorselector) {	 	    	 		
	 	    	 		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'No error log file and ajax handler object not set OR retry is set to false, we are displaying an error notice for ' + handling_mode + ' request.', handling_mode, source);
	 	    	 		MultisiteMigrationCoreJSObject.user_notices( errorselector + multisiteblog_id, multisiteblog_id, 'import', true );
	 	    	 	}			                
	            },
	            error : function(xhr, textStatus, errorThrown ) {
	            	this.tryCount++;
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, handling_mode + ' retry mode is' + retry, handling_mode, source);
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'The error handling ajax returns an error.', handling_mode, source);
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'The error returned is ' + errorThrown, handling_mode, source);            	
	            	if (retry) {
	            		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'We are now retrying the original ' + handling_mode + ' request', handling_mode, source);
	            		MultisiteMigrationCoreJSObject.retryAjaxHandler(ajax_handler_object, handling_mode, multisiteblog_id, source);	            		
	            	}
	            	
	            } 
	        });	        
    	},
    	/**
    	 * Retry helper
    	 */
    	retryHelper: function(ajax_handler_object) {
    		$.ajax(ajax_handler_object);    		
    	},
    	/**
    	 * Retry ajax handler for error handling
    	 */
    	retryAjaxHandler: function(ajax_handler_object, mode, multisiteblog_id, source) {
    		if (typeof( multisiteblog_id ) === 'undefined') {
    			return;
    		}
    		if (typeof( source ) === 'undefined') {
    			source = ''
    		}
    		if ( ! ajax_handler_object ) {
    			MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Ajax handler object is not defined.', mode, source);
    			return;
    		}
    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Retry ajax handler method called.', mode, source);
    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Set retry limit is ' + ajax_handler_object.retryLimit, mode, source);
    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Current retry count is ' + ajax_handler_object.tryCount, mode, source);

    		if ('import' === mode) {
                if (ajax_handler_object.tryCount <= ajax_handler_object.retryLimit) {
            		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'The original ajax request has been retried.', mode, source);
            		setTimeout(function() { MultisiteMigrationCoreJSObject.retryHelper(ajax_handler_object); }, 2000);            		
                    return;
                } else if ( ajax_handler_object.tryCount > ajax_handler_object.retryLimit ) {
                	MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id, true, mode, true );
                	var uploaderror_selector = MultisiteMigrationCoreJSObject.getGenericFailSelector(multisiteblog_id);
                	if ( false === MultisiteMigrationCoreJSObject.dialogIsOpen(uploaderror_selector, true) ) {               			
                		var text = '';
                		if ('errorReturned' in ajax_handler_object) {
                			text = ajax_handler_object.errorReturned;
                		}
                		var clearprogressspans = false;
                		var blogid = 0;
                		var notice_mode = '';
                		MultisiteMigrationCoreJSObject.lockDownButtons(multisiteblog_id, false);
                		if ('clearprogressspans' in ajax_handler_object) {
                			clearprogressspans = ajax_handler_object.clearprogressspans;
                			blogid = multisiteblog_id;
                			notice_mode = mode;
                		}             		
                		MultisiteMigrationCoreJSObject.user_notices( uploaderror_selector, blogid, notice_mode, clearprogressspans, text );
                	}
                }   			
    		}   		
    	},
    	/**
    	 * Get generic fail selector
    	 */
    	getGenericFailSelector: function(multisiteblog_id) {
    		return '#js-multisite-migration-import-generic-fail-' + multisiteblog_id;
    	},
    	/**
    	 * Helper dialog for outputting user notices
    	 */
    	user_notices: function ( selector, multisiteblog_id, mode, clearprogress, text ) {
    		if (typeof( multisiteblog_id ) === 'undefined') {
    			multisiteblog_id = 0;
    		}
    		if (typeof( mode ) === 'undefined') {
    			mode = '';
    		}    		
    		if (typeof( clearprogress ) === 'undefined') {
    			clearprogress = false;
    		}
    		if (typeof( text ) === 'undefined') {
    			text = '';
    		}
            var data = $(selector).data();
            data.multisiteblog_id = multisiteblog_id;
            data.mode = mode;
            data.clearprogress = clearprogress;
            if (text) {
            	$(selector + " p").html(text);
            }
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'We are displaying a user notice with following args.', mode, 'user_notices');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Selector: ' + selector, mode, 'user_notices');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Clear progress: ' + clearprogress, mode, 'user_notices');
            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Text: ' + text, mode, 'user_notices');
            
			$( selector ).dialog({
	            resizable: false,
	            height: "auto",	            
	            minWidth: 320,
	            maxWidth: 600,
	            modal: true,
	            fluid: true,			
				buttons: [
				    {
				      text: multisite_migration_js_ajax_renderer.ok_button,	
				      "class": 'button-primary',
				      click: function() {
				    	  var dialog_object = this;				    	  
		            	  $(dialog_object).dialog( "close" );		            	  
		            	  MultisiteMigrationCoreJSObject.runThisWhenUserNoticeIsClosed(dialog_object);
					   }
				    }				    
				 ],
 		         create: function() {
 		        	  var dialog_object = this;
		              $(dialog_object).closest('div.ui-dialog')
		                 .find('.ui-dialog-titlebar-close')
		                 .click(function(e) {						     
						     MultisiteMigrationCoreJSObject.runThisWhenUserNoticeIsClosed(dialog_object);						  
		                 });
		        }				 
	          });
		  MultisiteMigrationCoreJSObject.handle_responsive_dialog();   		
    	},
    	/**
    	 * Run this user notice when closed
    	 */
    	runThisWhenUserNoticeIsClosed: function(dialog_object) {
	    	var multisiteblog_id = $(dialog_object).data('multisiteblog_id');
	    	var mode = $(dialog_object).data('mode');	
	    	var clearprogress = $(dialog_object).data('clearprogress');
	    	  
	    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'A user notice is closed with the following parameters:', mode, 'user_notices');
	    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Multisite ID: ' + multisiteblog_id, mode, 'user_notices');
	    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Clear progress: ' + clearprogress, mode, 'user_notices');
	    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Mode: ' + mode, mode, 'user_notices');
	    	  
	    	if (multisiteblog_id && clearprogress && mode) {
	    	  MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'A clear progress has been successfully requested after closing notice.', mode, 'user_notices');
	    	  MultisiteMigrationCoreJSObject.cleanProgressSpans(multisiteblog_id, mode);			    		  
	    	}    		
    	},
    	/**
    	 * Initiate spinner
    	 */
    	initiateSpinner: function(multisiteblog_id, spinner_mode) {
            if (typeof( spinner_mode ) === 'undefined') {
            	spinner_mode = 'upload';
            }
            var spinner_text = multisite_migration_js_ajax_renderer.multisite_migration_spinner_upload_text;
            if ('download' === spinner_mode ) {
            	spinner_text = multisite_migration_js_ajax_renderer.multisite_migration_spinner_download_text;
            }
            if ('zip_analysis' === spinner_mode) {
            	spinner_text = multisite_migration_js_ajax_renderer.multisite_migration_spinner_zipanalysis_text;
            }
	    	//User confirms import
			//Spinner
			var html_ajax_loader='<img src="'+ multisite_migration_js_ajax_renderer.multisite_migration_ajax_ajax_loader_gif + '" />';
			
			//Append to span
			$('#js-multisite_import_span_'+ multisiteblog_id ).html( html_ajax_loader );
			
			//Add progress text
			$('#js-multisite_import_progress_span_'+ multisiteblog_id ).html( spinner_text + '..<progress></progress>' );   		
    	},
    	/**
    	 * User confirms to proceed to the import
    	 */
    	user_confirms_import_to_proceed: function( multisiteblog_id, the_import_package ) {

			/**
			 * Overcome upload max size server limitation by uploading "slices of package" instead of a huge one.
			 */
			MultisiteMigrationCoreJSObject.processFile( the_import_package, multisiteblog_id);   		
    	},
        /**
         * Validate if server upload limits insufficient
         * file_size value should already be valid at this point
         */
		validate_if_server_upload_limits_insufficient: function ( file_size ) { 
			
			$insufficient	= false;  
			
        	//Get file size of the package being uploaded
        	var package_size	= file_size;
        	
        	//Get upload_max_size of this server
        	var server_upload_max_size	= multisite_migration_js_ajax_renderer.multisite_migration_upload_max_size;
        	
        	//Check if package size is greater than the upload_max_size
        	if ( package_size > server_upload_max_size ) {
        		$insufficient	= true;
        	}
        	return $insufficient;
        },
        /**
         * Compute recommended upload_max_size and post_max_size based on given imported package
         * file_size value should already be valid at this point
         */
        compute_recommended_upload_parameters: function ( file_size ) {    			  		
        	//Get file size of the package being uploaded
        	var package_size	= file_size;
        	
        	//Compute upload_max_size
        	var upload_max_size_recommended	= Math.ceil( package_size + package_size * 0.10 );
        	
        	return upload_max_size_recommended;
        },
        /**
         * Import success handler
         */
        import_success_handler: function ( multisiteblog_id, myObj_multisite_migration_import_status ) {  
            if (typeof(myObj_multisite_migration_import_status) === 'undefined') {
            	myObj_multisite_migration_import_status = null;
            }
        	var checked_success = multisite_migration_js_ajax_renderer.multisite_migration_complete_import_png;
        	if ( myObj_multisite_migration_import_status && this.multisite_migration_is_js_object( myObj_multisite_migration_import_status ) ) {
        		checked_success = myObj_multisite_migration_import_status.import_successful;
        	}
        	if ((parseInt( multisiteblog_id ) > 0 )) {
 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).html( '' );	
 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).html(checked_success); 
 	    		$('#js-multisite_import_progress_span_'+ multisiteblog_id ).html( multisite_migration_js_ajax_renderer.multisite_migration_restore_done ); 
        	}            	
        },
        /**
         * Import failure handler
         */
        import_failed_handler: function ( multisiteblog_id, myObj_multisite_migration_import_status ) {  
        	if ( ! multisiteblog_id ) {
        		return;
        	}
        	if ( this.multisite_migration_is_js_object( myObj_multisite_migration_import_status ) ) {
 	    		//Import unsuccessful, display error			 	    		
 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).html( myObj_multisite_migration_import_status.import_not_successful ); 	    			          		
        	} else {        		
        		$('#js-multisite_import_span_'+ multisiteblog_id ).html( myObj_multisite_migration_import_status );
        	}        	
        	$('#js-multisite_import_span_'+ multisiteblog_id ).css( 'color', 'red' );
        },
        /**
         * Clean import and export progress pans
         */
        cleanProgressSpans: function(multisiteblog_id, mode) {
            if (typeof(mode) === 'undefined') {
            	mode = 'import';
            }
        	var span_selector = '#js-multisite_migration_' + mode + '_progress_span_p_' + multisiteblog_id + ' span';
        	$(span_selector).html('');
        	$(span_selector).removeAttr('style');           
        },
        /**
         * Clear progress text
         */
        stop_interval_clear_progress_text: function ( multisiteblog_id, cleartext, mode, clear_spinner ) {
            if (typeof( cleartext ) === 'undefined') {
            	cleartext = true;
            }
            if (typeof( mode ) === 'undefined') {
            	mode = 'import';
            }
            if (typeof( clear_spinner ) === 'undefined') {
            	clear_spinner = false;
            }
            var refreshid = this.generateRefreshID( mode, multisiteblog_id );
        	if ( parseInt( multisiteblog_id ) > 0 ) {
        		if ( cleartext ) {
        			$('#js-multisite_' + mode + '_progress_span_'+ multisiteblog_id ).text('');
        		}	   
        		if ( this.isRefreshIDSet(refreshid) ) {
        			clearTimeout(MultisiteMigrationCoreJSObject[refreshid]); 
        			MultisiteMigrationCoreJSObject[refreshid] = false;
        		}
        		if ( clear_spinner) {
        			$('#js-multisite_' + mode + '_span_'+ multisiteblog_id ).text('');
        		}
        	}          	
        },
        /**
         * is object
         */
        multisite_migration_is_js_object: function ( obj ) {
        	return obj === Object(obj);
        },
        /**
         * Slice package into 1MB size
         */
        slice: function( file, start, end ) {
    	  var slice = file.mozSlice ? file.mozSlice :
              file.webkitSlice ? file.webkitSlice :
              file.slice ? file.slice : noop;
  
    	  return slice.bind(file)(start, end);       	
        },
        /**
         * Noop
         */
        noop: function() {
        	
        },
        
        /**
         * Compute canonical total chunks
         */
        compute_canonical_total_chunks: function ( size, sliceSize ) {
        	
      	  var chunks = size/sliceSize;
    	  chunks = Math.ceil( chunks );
    	  
    	  return chunks;        	
        },        
        /**
         * Process file uploading by batches
         */
        processFile: function ( file, multisiteblog_id) {    	
          
    	  var size = file.size;
    	  var sliceSize = Number( multisite_migration_js_ajax_renderer.multisite_migration_slice_size ); 	  
    	  
    	  var start = 0;
    	  var chunks = this.compute_canonical_total_chunks( size, sliceSize );
    	  var uploadId = this.generateUploadId(multisiteblog_id);
    	  MultisiteMigrationCoreJSObject[uploadId] = {};
    	  
    	  setTimeout(loop, multisite_migration_js_ajax_renderer.multisite_migration_upload_refresh_interval);
    	  var slice_part = 1;
    	  function loop() {
	        
    	    var end = start + sliceSize;
    	    
    	    if (size - end < 0) {
    	      end = size;
    	    }
    	    
    	    var s = MultisiteMigrationCoreJSObject.slice(file, start, end );
    	    MultisiteMigrationCoreJSObject.outputProcessFileDebugLog( start, end, slice_part, chunks, sliceSize, size );
    	    
    	    MultisiteMigrationCoreJSObject[uploadId][slice_part] = {slice_start:start, slice_end:end};    
    	    MultisiteMigrationCoreJSObject.send(s, start, end, slice_part, chunks, multisiteblog_id, file, sliceSize );

    	    slice_part++;
    	    
    	    if (end < size) {
    	      start += sliceSize;      
    	      setTimeout(loop, multisite_migration_js_ajax_renderer.multisite_migration_upload_refresh_interval);
    	    }
    	  }
        },
        /**
         * Process file debug logs
         */
        outputProcessFileDebugLog: function( start, end, slice_part, chunks, sliceSize, size ) { 
        	if ( multisite_migration_js_ajax_renderer.multisite_migration_debug_uploads ) {
        	    console.log( '******************************' );
        	    console.log( 'start: ' + start );
        	    console.log( 'end: ' + end );
        	    console.log( 'chunk: ' + slice_part );
        	    console.log( 'chunks: ' + chunks );
        	    console.log( 'sliceSize: ' + sliceSize );
        	    console.log( 'size: ' + size );
        	    console.log( '******************************' );        		
        	}    	    
        },
        /**
         * Generate upload ID
         */
        generateUploadId: function(multisiteblog_id) {
    		var uploadId = 'uploadID_' + multisiteblog_id;
    		return uploadId;        	
        },
        /**
         * Sends chunks of package to server
         */
        send: function( piece, start, end, chunk, chunks, multisiteblog_id, file, sliceSize, missing_chunk_to_fix ) {
            
        	if (typeof( missing_chunk_to_fix ) === 'undefined') {
        		missing_chunk_to_fix = 0;
            }
            
		    var ajaxData = new FormData();
		    var filename = file.name;
		    
		    ajaxData.append( 'action', 'multisite_migration_process_uploads' );
		    ajaxData.append( 'multisite_migration_uploads_nonce', multisite_migration_js_ajax_renderer.multisite_migration_uploads_nonce );
		    ajaxData.append( 'multisite_blogid_to_import', multisiteblog_id );	
		    ajaxData.append( 'start', start );
		    ajaxData.append( 'end', end );
		    ajaxData.append( 'file', piece, filename );	
		    ajaxData.append( 'chunk', chunk );
		    ajaxData.append( 'chunks', chunks );
		    ajaxData.append( 'missing_chunk_to_fix', missing_chunk_to_fix );
						
			jQuery.ajax({
	            url: ajaxurl,
	            type: 'post',
	            data: ajaxData,
	            cache: false,	
	            contentType: false, 
	            processData: false,
	            tryCount : 0,	
	            errorReturned: '',
	            clearprogressspans: true,
	            retryLimit : multisite_migration_js_ajax_renderer.multisite_migration_retry_limit,
	            success: function( response ) {					            	
	 	    	 	var myObj_multisite_migration_upload_status = response;			 	    	 				 	    	 	
		 	    	if ( ( 'status' in myObj_multisite_migration_upload_status && true  === myObj_multisite_migration_upload_status.status ) && 
		 	    		 ( 'done' in myObj_multisite_migration_upload_status && false ===  myObj_multisite_migration_upload_status.done ) ) {	
		 	    		
		 	    		//No error status but the uploading is not yet done.
		 	    		var chunk = myObj_multisite_migration_upload_status.chunk;
		 	    		var chunks = myObj_multisite_migration_upload_status.chunks;
		 	    		
                        $('#js-multisite_import_progress_span_' + multisiteblog_id + ' progress').attr({
                            value: chunk,
                            max: chunks,
                        });                        
		 	    		
		 	    	} else if ( ( 'done' in myObj_multisite_migration_upload_status && true === myObj_multisite_migration_upload_status.done ) &&  
		 	    			    ( 'filepath'in myObj_multisite_migration_upload_status && myObj_multisite_migration_upload_status.filepath ) ) {		 	    		
		 	    		//Uploading is done and filepath is set
		 	    		var filepath = myObj_multisite_migration_upload_status.filepath;
		 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Upload completed', 'import', 'send');
		 	    		MultisiteMigrationCoreJSObject.import_handler( multisiteblog_id, filepath );
		 	    	
		 	    	} else if ( 'missing_chunk' in myObj_multisite_migration_upload_status ) {	
		 	    		
		 	    		var uploadId = MultisiteMigrationCoreJSObject.generateUploadId(multisiteblog_id);
		 	    			
		 	    		//Request to re-upload missing chunk
		 	    		var missing_chunk = myObj_multisite_migration_upload_status.missing_chunk;                    	                    
		 	    		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Processing missing chunk found: ' + missing_chunk, 'import', 'send');
		 	    		
	                    /**
	                     * Diagnostics and data definition.
	                     */
	                    var filesize_under_process = file.size;
	                    var filename_test = file.name;	                    
	                    var chunks = MultisiteMigrationCoreJSObject.compute_canonical_total_chunks( filesize_under_process, sliceSize );	                    
	                    
	                    /**
	                     * Re-slice again the missing chunk
	                     * Given the chunk, get its original start and end
	                     */
	                    var uploadfootprint = MultisiteMigrationCoreJSObject[uploadId];
	                    var missing_chunk_start = uploadfootprint[missing_chunk].slice_start;
	                    var missing_chunk_end = uploadfootprint[missing_chunk].slice_end;
	                    var piece_missing_chunk = MultisiteMigrationCoreJSObject.slice(file, missing_chunk_start, missing_chunk_end );
	                    
	                    /**
	                     * Re-upload the missing chunk back to server
	                     */	                    
	                    var missing_chunk_to_fix = missing_chunk;	                    	                    
	                    
	                    MultisiteMigrationCoreJSObject.outputMissingChunkDebugLog( missing_chunk, filesize_under_process, filename_test, sliceSize, chunks, missing_chunk_start, missing_chunk_end );
	                    
	                    setTimeout(function() { MultisiteMigrationCoreJSObject.send( piece_missing_chunk, missing_chunk_start, missing_chunk_end, missing_chunk, 
	                    		chunks, multisiteblog_id, file, sliceSize, missing_chunk_to_fix ); }, multisite_migration_js_ajax_renderer.multisite_migration_upload_refresh_interval);
	                    
		 	    	} else if ( 'error' in myObj_multisite_migration_upload_status && myObj_multisite_migration_upload_status.error ) {		 	    		
		 	    		
		 	    		//Error status detected
		 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).html( myObj_multisite_migration_upload_status.error );
		 	    		$('#js-multisite_import_span_'+ multisiteblog_id ).css( 'color', 'red' );
		 	    		
		 	    	}				 	    		                
	            },
	            error : function(xhr, textStatus, errorThrown ) {	
	            	    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Error returned by AJAX chunk upload, textStatus is: ' + textStatus, 'import', 'send');
	            	    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Error returned by AJAX chunk upload, error thrown is: ' + errorThrown, 'import', 'send');
	            	    this.tryCount++;
	            	    if (errorThrown) {
		                	var msg = multisite_migration_js_ajax_renderer.multisite_migration_upload_error_message;
		        			msg = msg.replace('{{UPLOADSERVERERROR}}', errorThrown);
		        			msg = msg.replace('{{BLOGID}}', multisiteblog_id);
		                	
		            	    this.errorReturned = msg;	
		            	    this.clearprogressspans = true;	            		
	            	    }

	            	    var ajax_handler_object = this;
	                    MultisiteMigrationCoreJSObject.doErrorHandling(multisiteblog_id, 'import', ajax_handler_object, '', true, 'send');
	            }
	        });	    	  
        },
        /**
         * Monitor the number of times the dialog is open.
         */
        dialogOpened: [],
        /**
         * Initialize dialog monitor
         */
        initializeDialogMonitor: function(diagselector, reset) {
    		if (typeof(reset) === 'undefined') {
    			reset = false;
    		} 
    		if (typeof(this.dialogOpened[diagselector]) === 'undefined') {
    			this.dialogOpened[diagselector] = 1;
    		} 
    		if (reset) {
    			this.dialogOpened[diagselector] = 1;
    		}
        },
        /**
         * Checks if dialog is open
         */
        dialogIsOpen: function( diagselector, show_only_once ) {
        	var ret = false;
        	if ( $(diagselector).hasClass("ui-dialog-content") && $(diagselector).dialog("isOpen") ) {
        		ret = true;
        	}
        	
        	if (typeof( show_only_once ) === 'undefined') {
        		show_only_once = false;
            } 
        	if (show_only_once) {
        		this.initializeDialogMonitor(diagselector); 
            	if ( false === ret && 1 === this.dialogOpened[diagselector] ) {            		
            		this.dialogOpened[diagselector]++;   
            		return false;
            	} else {
            		return true;
            	}
        	} else {
        		return ret;
        	}
        },
        /**
         * Output missing chunk debug log info
         */
        outputMissingChunkDebugLog: function( missing_chunk, filesize_under_process, filename_test, sliceSize, chunks, missing_start, missing_end ) {
        	if ( multisite_migration_js_ajax_renderer.multisite_migration_debug_uploads ) {
        		console.log( '******************************' );
                console.log( 'Requesting to re-upload missing chunk ' + missing_chunk );
        	    console.log( 'Missing start: ' + missing_start );
        	    console.log( 'Missing end: ' + missing_end );
                console.log( 'Re-uploading chunk request Filesize test: ' + filesize_under_process );
                console.log( 'Re-uploading chunk request Filename test' + filename_test );	                    
                console.log( 'Re-uploading chunk request Slice size test: ' + sliceSize );
                console.log( 'Total chunks of entire upload package is: ' + chunks ); 
                console.log( '******************************' );
        	}        	
        },
        /**
         * Compute end of missing chunk
         */
        compute_end_of_missing_chunk: function( sliceSize, chunk, chunks, filesize_under_process ) {
        	
        	var end = 0;        	
        	if  ( chunk === chunks ) {
        		
        		//This is the last chunk, end size automatically is the file size
        		end = filesize_under_process;
        		
        	} else {
        		//Not the last chunk, end size depends on slice size and the chunk #
        		end = sliceSize * chunk;        		
        	}
        	
        	return end;        	
        },
        /**
         * User approves diff
         */
        user_approves_diff: function ( myObj_multisite_migration_import_status, multisiteblog_id ) {
        	
 			//User confirms to proceed import!
 			//Repost in-progress data to ajax			 	    			
 			var in_progress_data	= myObj_multisite_migration_import_status.results;	
 			in_progress_data	 	= JSON.stringify( in_progress_data );
 			var nonce_to_continue	= myObj_multisite_migration_import_status.continue_nonce;
 			
	        var continueajaxData = new FormData();
	    	continueajaxData.append( 'action', 'multisite_migration_process_import' );
	    	continueajaxData.append( 'nonce_to_continue', nonce_to_continue );
	    	continueajaxData.append( 'data_to_continue', in_progress_data );	
	    	continueajaxData.append( 'diff_blog_id', multisiteblog_id );
	    	
	    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'User approves diff, now resending ajax.', 'import', 'user_approves_diff');	 
	    	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, continueajaxData, 'import', 'user_approves_diff');

	    	MultisiteMigrationCoreJSObject.multisite_migration_track_progress('import', multisiteblog_id, true, continueajaxData);      	
        },
        /**
         * User rejects diff
         */
        user_rejects_diff: function ( myObj_multisite_migration_import_status, multisiteblog_id ) {
        	
 			//Cancel event, delete temp file				 	    			
 			if ( 'unzipped_directory' in myObj_multisite_migration_import_status.results ) { 				
	 	    	MultisiteMigrationCoreJSObject.requestToDeleteTmpFile(myObj_multisite_migration_import_status.results.unzipped_directory, multisiteblog_id, true);
 			}        	
        },
        /**
         * Handler to delete any temp files during upload/download process
         */
        requestToDeleteTmpFile: function(path_to_delete, multisiteblog_id, diff_reject) {
        	if ( ! path_to_delete ) {
        		return;
        	}        	
		    var data = {
	      			action: 'multisite_tempfile_cancel',
	   				dataType: 'json',	 
	   				temp_file_to_delete : path_to_delete,
	   				multisite_migration_deletetmpfile_nonce: multisite_migration_js_ajax_renderer.multisite_migration_deletetmpfile_nonce,
	   				diff_reject: diff_reject
	    	};		     					    
	 	     $.post( multisite_migration_js_ajax_renderer.ajaxurl, data, function( response ) {
	 	    	 	var myObj_multisite_deletetmpfile_status = response;		
	 	    	 	$('#js-multisite_import_span_'+ multisiteblog_id ).html( '' );	
	 	    	 	if ( myObj_multisite_deletetmpfile_status.tempfile_deletion_status ) {	 	    	 									 	    			
	 	    			MultisiteMigrationCoreJSObject.user_notices( '#js-multisite-migration-cancel-import-diff-' + multisiteblog_id );
	 	    	 	} else {	 	    	 				 	    	 		
	 	    	 		MultisiteMigrationCoreJSObject.user_notices( '#js-multisite-migration-cancel-import-diff-fail-' + multisiteblog_id );
	 	    	 	}
	 	     });
 	    	 MultisiteMigrationCoreJSObject.stop_interval_clear_progress_text( multisiteblog_id );        	
        },
        /**
         * Formally processes the import after successful uploading
         */
        import_handler: function( multisiteblog_id, filepath ) {
        	
		    var ajaxData = new FormData();
		    ajaxData.append( 'action', 'multisite_migration_process_import' );
		    ajaxData.append( 'multisite_migration_import_nonce', multisite_migration_js_ajax_renderer.multisite_migration_import_nonce );
		    ajaxData.append( 'multisite_blogid_to_import', multisiteblog_id );				
		    ajaxData.append( 'multisite_import_package_uploaded_file', filepath );
		    MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Import_handling requested for this blog. Starting import..', 'import', 'import_handler');
		    
			$.ajax({
	            url: ajaxurl,
	            type: 'post',
	            data: ajaxData,
	            cache: false,	
	            contentType: false,	            
	            processData: false,
	            tryCount : 0,
	            retryLimit : multisite_migration_js_ajax_renderer.multisite_migration_retry_limit,
	            success: function( response ) {					            					 	    		                
	            },
	            error : function(xhr, textStatus, errorThrown ) {	            	
	            	this.tryCount++;
	            	var import_ajax_handler_object = this;	 
	            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Error found on import_handler() ajax request, starting error handling and retrying..', 'import', 'import_handler');	            	
	            	
	            	var retry = false;
	            	var refreshid =  MultisiteMigrationCoreJSObject.generateRefreshID('import', multisiteblog_id);
		            
	            	var progress_identifier =  MultisiteMigrationCoreJSObject.generateProgressIdentifier(refreshid, 'import');	            
		            MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Progress identifier at import_handler error handler: ' + progress_identifier, 'import', 'import_handler');
		            
		            if (typeof MultisiteMigrationCoreJSObject[progress_identifier] !== 'undefined') {
		            	var latest_progress = MultisiteMigrationCoreJSObject[progress_identifier];	
		            	MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'At import handler error, latest progress found is ' + latest_progress, 'import', 'import_handler');
		            	if ('boot' === latest_progress) {
		            		retry = true;
		            		MultisiteMigrationCoreJSObject.logProcessingErrorAnalysis(multisiteblog_id, 'Still boot process, retrying to avoid stuck on this stage.' + latest_progress, 'import', 'import_handler');
		            	}		            	
		            }		            
		            MultisiteMigrationCoreJSObject.doErrorHandling( multisiteblog_id, 'import', import_ajax_handler_object, null, retry, 'import_handler' ); 	            
	            } 
	        });        	
        },
        /**
         * Do after closing diff dialog for which user cancelled.
         */
        doAfterClose: function( import_diff_selector, myObj_multisite_migration_import_status, multisiteblog_id ) {       	  
       	  $( import_diff_selector ).text('');
      	  MultisiteMigrationCoreJSObject.user_rejects_diff( myObj_multisite_migration_import_status, multisiteblog_id );      	
        },
        /**
         * Fluid Dialog handler
         */
        fluidDialog: function() {            
            var $visible = $(".ui-dialog:visible");        	    
            $visible.each(function () {
                var $this = $(this);
                var dialog = $this.find(".ui-dialog-content").data("ui-dialog");        	        
                if (dialog.options.fluid) {
                    var wWidth = $(window).width();        	            
                    if (wWidth < (parseInt(dialog.options.maxWidth) + 50))  {        	                
                        $this.css("max-width", "90%");
                    } else {        	        	
                	var adjusted_width = 0.9 * parseInt(dialog.options.maxWidth);                	
                        $this.css("max-width", adjusted_width + "px");
                    }        	            
                    dialog.option("position", dialog.options.position);
                }
           });       	
        },
        /**
         * Handle responsive dialog
         */
        handle_responsive_dialog: function() {
	    $(window).resize(function () {
	      MultisiteMigrationCoreJSObject.fluidDialog();
  	    });
	    MultisiteMigrationCoreJSObject.fluidDialog();        	
        }
        
    };    
}(jQuery));
